% This Matlab GUI is a demo of finding ray-polygon intersections.
% Doug Johnson for CSE 457, Au 2003
% $Id: raygui.m,v 1.10 2003/08/17 21:27:07 finson Exp $
%
function varargout = raygui(varargin)
% RAYGUI M-file for raygui.fig
%      RAYGUI, by itself, creates a new RAYGUI or raises the existing
%      singleton*.
%
%      H = RAYGUI returns the handle to a new RAYGUI or the handle to
%      the existing singleton*.
%
%      RAYGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in RAYGUI.M with the given input arguments.
%
%      RAYGUI('Property','Value',...) creates a new RAYGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before raygui_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to raygui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help raygui

% Last Modified by GUIDE v2.5 16-Aug-2003 18:30:10

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @raygui_OpeningFcn, ...
    'gui_OutputFcn',  @raygui_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --------------------------------------------------------------------
% --- Executes just before raygui is made visible.
function raygui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to raygui (see VARARGIN)

% Choose default command line output for raygui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% This sets up the initial plot - only do when we are invisible
% so window can get raised using raygui.
if strcmp(get(hObject,'Visible'),'off')
    handles.axis_x = [-5 0; 5 0];
    handles.axis_y = [0 -5; 0 5]; 
    handles.polygon_radius = 2;
    handles.polygon_center_x = 0;
    handles.polygon_center_y = 0;
    guidata(hObject, handles);
    calculate_curve(hObject)
    draw_figure(hObject)
end

% --------------------------------------------------------------------
% UIWAIT makes raygui wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --------------------------------------------------------------------
% --- Outputs from this function are returned to the command line.
function varargout = raygui_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --------------------------------------------------------------------
function FileMenu_Callback(hObject, eventdata, handles)
% hObject    handle to FileMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function OpenMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to OpenMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
file = uigetfile('*.fig');
if ~isequal(file, 0)
    open(file);
end

% --------------------------------------------------------------------
function PrintMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to PrintMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
printdlg(handles.figure1)

% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
    ['Close ' get(handles.figure1,'Name') '...'],...
    'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

delete(handles.figure1)

% --------------------------------------------------------------------
% --- Executes during object creation, after setting all properties.
function face_count_CreateFcn(hObject, eventdata, handles)
% hObject    handle to face_count (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --------------------------------------------------------------------
% --- Executes on selection change in face_count.
function face_count_Callback(hObject, eventdata, handles)
calculate_curve(hObject)
draw_figure(hObject)

% --------------------------------------------------------------------
% --- Executes during object creation, after setting all properties.
function select_polygon_CreateFcn(hObject, eventdata, handles)
% hObject    handle to select_polygon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --------------------------------------------------------------------
% --- Executes on selection change in select_polygon.
function select_polygon_Callback(hObject, eventdata, handles)
calculate_curve(hObject)
draw_figure(hObject)

% --------------------------------------------------------------------
% --- Executes on mouse click in the axes.
function axes1_ButtonDownFcn(hObject, eventdata)
% hObject    handle to axes1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
handles = guidata(hObject);
point = get(handles.axes1,'CurrentPoint');

if point(2,1,1) < 0
    set(handles.X1,'String',num2str(point(2,1,1)))
    set(handles.Y1,'String',num2str(point(2,2,1)))
else
    set(handles.X2,'String',num2str(point(2,1,1)))
    set(handles.Y2,'String',num2str(point(2,2,1)))
end

guidata(hObject, handles);

calculate_curve(hObject)
draw_figure(hObject)

% --------------------------------------------------------------------
% calculate the various (x,y) lists
% fig       figure handle (or figure child component handle)
function calculate_curve(fig)
handles = guidata(fig);

% the ray

handles.ray_x = [str2num(get(handles.X1,'String'));str2num(get(handles.X2,'String'))];
handles.ray_y = [str2num(get(handles.Y1,'String'));str2num(get(handles.Y2,'String'))];

x1 = handles.ray_x(1);
x2 = handles.ray_x(2);
y1 = handles.ray_y(1);
y2 = handles.ray_y(2);

% the polygon

val = get(handles.select_polygon,'Value');
string_list = get(handles.select_polygon,'String');
selectedType = string_list{val}; % convert from cell array to string

val = get(handles.face_count,'Value');
string_list = get(handles.face_count,'String');
selected_string = string_list{val}; % convert from cell array to string
nFaces = str2num(selected_string);

xc = handles.polygon_center_x;
yc = handles.polygon_center_y;
radius = handles.polygon_radius;

handles.polygon_x = [];
handles.polygon_y = [];
handles.guide_x = [];
handles.guide_y = [];

switch selectedType
    case 'circle'
        set(handles.face_count,'Enable','off');
        t = 0:.01:1;
        handles.polygon_x = radius*cos(2*pi*t');
        handles.polygon_y = radius*sin(2*pi*t');
    case 'polygon'
        set(handles.face_count,'Enable','on');
        t = 0:1/nFaces:1;
        handles.polygon_x = radius*cos(2*pi*t');
        handles.polygon_y = radius*sin(2*pi*t');
        for face = 1:length(handles.polygon_x)-1
            px1 = handles.polygon_x(face);
            py1 = handles.polygon_y(face);
            px2 = handles.polygon_x(face+1);
            py2 = handles.polygon_y(face+1);
            
            % Start with two point form of equation of line
            % (y-py1)*(px2-px1) = (x-px1)*(py2-py1)
            % Solve for A, B and C of the standard form
            % Ax + By + C = 0
            
            A = py2 - py1;
            B = -(px2 - px1);
            C = py1*(px2 - px1) - px1*(py2 - py1);
            
            % if line is more vertical than horizontal then
            if abs(A) > abs(B)    % then solve for intersections with top and bottom limit lines
                guide = [A B;0 1]\[-C -C; handles.axis_y(1,2) handles.axis_y(2,2)];
            else        % else solve for intersections with left and right limit lines
                guide = [A B;1 0]\[-C -C; handles.axis_x(1,1) handles.axis_x(2,1)];
            end
            
            handles.guide_x = [handles.guide_x [guide(1,1);guide(1,2)]];
            handles.guide_y = [handles.guide_y [guide(2,1);guide(2,2)]];
        end
    otherwise
        set(handles.face_count,'Enable','off');
        beep
end

% the intersections

handles.intersect_t = [];
handles.intersect_x = [];
handles.intersect_y = [];
handles.marker_linespec = [];
handles.polygon_linespec = [];
mc = [.1 .1 1];             % marker color
handles.default_polygon_linespec = struct('Color',[1 0 0],'LineWidth',2,'LineStyle','-');

switch selectedType
    case 'circle'
        i = x2 - x1;
        j = y2 - y1;
        a = i^2 + j^2;
        b = 2*i*(x1-xc) + 2*j*(y1-yc);
        c = xc^2 + yc^2 + x1^2 + y1^2 + 2*(-xc*x1-yc*y1) - radius^2;
        d = b^2 - 4*a*c;
        
        if d < 0
            set(handles.message,'String','No intersection.')
            set(handles.tNear,'String','')
            set(handles.xNear,'String','')
            set(handles.yNear,'String','')
            set(handles.tFar,'String','')
            set(handles.xFar,'String','')
            set(handles.yFar,'String','')
        else
            set(handles.message,'String','Ray intersects circle.')
            tNear = (-b - sqrt(d))/(2*a);
            tFar = (-b + sqrt(d))/(2*a); 
            
            handles.intersect_t = [tNear];
            handles.intersect_x = [x1 + (i*tNear)];
            handles.intersect_y = [y1 + (j*tNear)];
            handles.marker_linespec = [ handles.marker_linespec ...
                    struct('Marker','<','MarkerEdgeColor',mc,'MarkerFaceColor',mc)];
            set(handles.tNear,'String',num2str(tNear))      
            set(handles.xNear,'String',num2str(handles.intersect_x(1)))      
            set(handles.yNear,'String',num2str(handles.intersect_y(1)))      
            
            if abs(tNear-tFar) > 5*eps
                handles.intersect_t = [handles.intersect_t tFar];
                handles.intersect_x = [handles.intersect_x; x1 + (i*tFar)];
                handles.intersect_y = [handles.intersect_y; y1 + (j*tFar)];
                handles.marker_linespec = [ handles.marker_linespec ...
                        struct('Marker','o','MarkerEdgeColor',mc,'MarkerFaceColor',mc)];
                set(handles.tFar,'String',num2str(tFar))
                set(handles.xFar,'String',num2str(handles.intersect_x(2)))      
                set(handles.yFar,'String',num2str(handles.intersect_y(2)))      
            else
                set(handles.tFar,'String','')
                set(handles.xFar,'String','')      
                set(handles.yFar,'String','')      
            end
        end
    case 'polygon'
        i = x2 - x1;
        j = y2 - y1;
        
        tNear = -realmax;
        tFar = realmax;
        handles.polygon_linespec = repmat(handles.default_polygon_linespec,1,length(handles.polygon_x)-1);
        for face = 1:length(handles.polygon_x)-1
            px1 = handles.polygon_x(face);
            py1 = handles.polygon_y(face);
            px2 = handles.polygon_x(face+1);
            py2 = handles.polygon_y(face+1);
            
            % Start with two point form of equation of line
            % (y-py1)*(px2-px1) = (x-px1)*(py2-py1)
            % Solve for A, B and C of the standard form
            % Ax + By + C = 0
            
            A = py2 - py1;
            B = -(px2 - px1);
            C = py1*(px2 - px1) - px1*(py2 - py1);
            
            % Solve for intersection of ray and face line
            % t = -(A*x1 + B*y1 + C) / (A*i + B*j)
            
            denom = (A*i + B*j);
            if abs(denom) > 5*eps           % ray not parallel to face line
                t = -(A*x1 + B*y1 + C) / denom;
                
                handles.intersect_t = [handles.intersect_t t];
                handles.intersect_x = [handles.intersect_x; x1 + (i*t)];
                handles.intersect_y = [handles.intersect_y; y1 + (j*t)];
                if denom > 0            % back-facing line
                    handles.polygon_linespec(face).LineStyle = '--';
                    marker = 'o';
                    if t < tFar
                        tFar = t;
                    end
                else                    % front-facing line
                    handles.polygon_linespec(face).LineStyle = '-';
                    marker = '<';
                    if t > tNear
                        tNear = t;
                    end
                end
                handles.marker_linespec = [ handles.marker_linespec ...
                        struct('Marker',marker,'MarkerEdgeColor',mc,'MarkerFaceColor','none')];
            end
        end
        for idx = 1:length(handles.marker_linespec)
            if handles.intersect_t(idx) == tNear
                set(handles.tNear,'String',num2str(tNear))      
                set(handles.xNear,'String',num2str(handles.intersect_x(idx)))      
                set(handles.yNear,'String',num2str(handles.intersect_y(idx)))      
                handles.marker_linespec(idx).MarkerFaceColor = mc;
            end
            if handles.intersect_t(idx) == tFar
                set(handles.tFar,'String',num2str(tFar))
                set(handles.xFar,'String',num2str(handles.intersect_x(idx)))      
                set(handles.yFar,'String',num2str(handles.intersect_y(idx)))    
                handles.marker_linespec(idx).MarkerFaceColor = mc;
            end
        end
        if tNear > tFar
            set(handles.message,'String','No intersection.')
        else
            set(handles.message,'String','Ray intersects polygon.')
        end
end

% all done

guidata(fig, handles);

% --------------------------------------------------------------------
% redraw the figure
% fig       figure handle (or figure child component handle)
function draw_figure(fig)
handles = guidata(fig);
cla
plot(handles.axis_x,handles.axis_y,'.','MarkerEdgeColor','none');
axis equal
axis manual
set(handles.axes1,'XTick',[])
set(handles.axes1,'YTick',[])
set(handles.axes1,'ButtonDownFcn',@axes1_ButtonDownFcn)
hold on

plot(handles.guide_x,handles.guide_y,'LineStyle','--','Color',[0.8,0.8,0.8])
if length(handles.polygon_linespec) == 0
    plot(handles.polygon_x,handles.polygon_y,handles.default_polygon_linespec)
else
    for i = 1:length(handles.polygon_linespec)
        plot(handles.polygon_x(i:i+1),handles.polygon_y(i:i+1),handles.polygon_linespec(i))
    end
end
plot(handles.ray_x,handles.ray_y,'.-b')
for i = 1:size(handles.intersect_x)
    plot(handles.intersect_x(i),handles.intersect_y(i),handles.marker_linespec(i));
end

h = findobj(gca,'Type','line');
set(h,'HitTest','off')
guidata(fig, handles);

return
